<?php
class plgHikashopMassaction_example extends JPlugin
{
	function plgHikashopMassaction_example(&$subject, $config){
		parent::__construct($subject, $config);
	}

	// Add a data type
	function onMassactionTableLoad(&$externalValues){
		$obj = new stdClass();
		$obj->table ='new_data';
		$obj->value ='new_data';
		$obj->text =JText::_('NEW_DATA');
		$externalValues[] = $obj;
	}

	// Add a dropdown filter for the product type
	function onMassactionTableFiltersLoad(&$table,&$filters,&$filters_html,&$loadedData){
		$type = 'filter';
		$massactionClass = hikashop_get('class.massaction');
		if(empty($loadedData->massaction_filters)){
			$loadedData->massaction_filters = array();
		}
		// Add the entry in the filters listing
		$filters['productType']=JText::_('PRODUCT_TYPE');
		$loadedData->massaction_filters['__num__'] = new stdClass();
		$loadedData->massaction_filters['__num__']->type = 'product';
		$loadedData->massaction_filters['__num__']->data = array();
		$loadedData->massaction_filters['__num__']->name = 'productType';
		$loadedData->massaction_filters['__num__']->data['type'] = 'all';
		$loadedData->massaction_filters['__num__']->html = '';

		foreach($loadedData->massaction_filters as $key => &$value) {
			if($value->name != 'productType' || ($table->table != $loadedData->massaction_table && is_int($key)))
				continue;

			$value->type = 'product';
			$product = hikashop_get('type.product');
			$product->onchange='countresults(\''.$table->table.'\','.$key.');';
			$output = $product->display('filter['.$table->table.']['.$key.'][productType][type]',$value->data['type'], 'chzn-done not-processed');
			$filters_html[$value->name] = $massactionClass->initDefaultDiv($value, $key, $type, $table->table, $loadedData, $output);
		}
	}

	// Filtering function
	function onProcessProductMassFilterproductColumn(&$elements,&$query,$filter,$num){
		$this->massaction = hikashop_get('class.massaction');
		if(empty($filter['type']) || $filter['type']=='all') return;
		if(!isset($this->massaction))$this->massaction = hikashop_get('class.massaction');
		if(count($elements)){
			foreach($elements as $k => $element){
				if(isset($element->$filter['type'])){
					$in = $this->massaction->checkInElement($element, $filter);
					if(!$in) unset($elements[$k]);
				}
			}
		}else{
			$db = JFactory::getDBO();
			if(!empty($filter['value']) || (empty($filter['value']) && in_array($filter['operator'],array('IS NULL','IS NOT NULL')))){
				$query->where[] = $this->massaction->getRequest($filter,'hk_product');
			}
		}
	}
	// Count the number of filtered elements
	function onCountProductMassFilterproductColumn(&$query,$filter,$num){
		$elements = array();
		$this->onProcessProductMassFilterproductColumn($elements,$query,$filter,$num);
		return JText::sprintf('SELECTED_PRODUCTS',$query->count('hk_product.product_id'));
	}

	// Delete products
	function onProcessProductMassActiondeleteElements(&$elements,&$action,$k){
		$ids = array();
		foreach($elements as $element){
			$ids[] = $element->product_id;
		}
		$productClass = hikashop_get('class.product');
		$result = $productClass->delete($ids);
	}
}
?>